%Program to plot the visibility versus the attenuation per km
close all; clear all; clc
% We going to define the constants at first :
C=3*(10^5);
% Considering the worst case by taking the maximum particle radius in m
%Rmax=538.04.*1e-6 ;
 
%ae= 500.*1e-6
% in this case we are assuming the height in m
h=0.001;
% the reference height in m 
ho= 0.002;
% the minimum visibility in km
%Vo= (4).*1e-3;
% we are assuming the frequency in Hz
f=(28);
w=2.*pi.*f;
lamd=(C./f).*1e-3;
ko=2.*pi./lamd;
EO=8.85e-12;

p=2.5764;  % density with unit gm/m^3
g=1.07; % constant gamma
b=0.28; % constant
%the humidity H=0
H=0;
H1=60;
H2=100;
%the complex pertivitty
c1=6.3485+(0.04.*H)-(7.78.*1e-4).*(H.^2)+(5.56.*1e-6).*(H.^3) 
c2=0.0929+0.02.*H-(3.71.*1e-4).*(H.^2)+(2.76.*1e-6).*(H.^3)

c11=6.3485+0.04.*H1-(7.78.*1e-4).*(H1.^2)+(5.56.*1e-6).*(H1.^3) 
c21=0.0929+0.02.*H1-(3.71.*1e-4).*(H1.^2)+(2.76.*1e-6).*(H1.^3)

c12=6.3485+0.04.*H2-(7.78.*1e-4).*(H2.^2)+(5.56.*1e-6).*(H2.^3)% real complex pemitivity
c22=0.0929+0.02.*H2-(3.71.*1e-4).*(H2.^2)+(2.76.*1e-6).*(H2.^3)%imaginary complex permitivity

% constant x
Vo= 0.001 ;
V=Vo.*(h./ho).^(b./g);
% Visbility of the particle in km
ae=0:0.00001:0.0007;

% The specific attenuation Ad (dB/km) is 
X2=(((c12.^2-c22.^2-2.*c12+1).*(c12.^2-c22.^2+2.*c12+4))+(4.*((c12.*c22)-c22).*((c12.*c22)+c22)))./((c12.^2-c22.^2+2.*c12+4)+(4.*((c12.*c22)+c22).^2));
Y2=(-2.*((c12.*c22)+c22).*((4.*c12)+3))./((c12.^2-c22.^2+2.*c12+4)+(4.*((c12.*c22)+c22).^2));
D4=(0.5).*((w.^2+ko.^2+EO.^2+ae.^6.*X2)+(4.*pi.*ae.^4.*w.*ko.*c22));
D5=(0.5).*((w.^2+ko.^2+EO.^2+ae.^6.*Y2)+(4.*pi.*ae.^4.*w.*ko.*(1-c12)));

X1=(((c11.^2-c21.^2-2.*c11+1).*(c11.^2-c21.^2+2.*c11+4))+(4.*((c11.*c21)-c21).*((c11.*c21)+c21)))./((c11.^2-c21.^2+2.*c11+4)+(4.*((c11.*c21)+c21).^2));
Y1=(-2.*((c11.*c21)+c21).*((4.*c11)+3))./((c11.^2-c21.^2+2.*c11+4)+(4.*((c11.*c2)+c21).^2));
D2=(0.5).*((w.^2+ko.^2+EO.^2+ae.^6.*X1)+(4.*pi.*ae.^4.*w.*ko.*c21));
D3=(0.5).*((w.^2+ko.^2+EO.^2+ae.^6.*Y1)+(4.*pi.*ae.^4.*w.*ko.*(1-c11)));

X=(((c1.^2-c2.^2-2.*c1+1).*(c1.^2-c2.^2+2.*c1+4))+(4.*((c1.*c2)-c2).*((c1.*c2)+c2)))./((c1.^2-c2.^2+2.*c1+4)+(4.*((c1.*c2)+c2).^2));
Y=(-2.*((c1.*c2)+c2).*((4.*c1)+3))./((c1.^2-c2.^2+2.*c1+4)+(4.*((c1.*c2)+c2).^2));
D=(0.5).*((w.^2+ko.^2+EO.^2+ae.^6.*X)+(4.*pi.*ae.^4.*w.*ko.*c2));
D1=(0.5).*((w.^2+ko.^2+EO.^2+ae.^6.*Y)+(4.*pi.*ae.^4.*w.*ko.*(1-c1)));



Ad=1e-16.*(2.389.*(D+i.*D1)./(V.*ae.^2));

Ad1=1e-16.*(2.389.*(D2+i.*D3)./(V.*ae.^2));
 
Ad2=1e-16.*(2.389.*(D4+i.*D5)./(V.*ae.^2));

% Ad=10.*log((238.9./(V.*ae)).*(D+j.*D1));
% FIGURE 

% plot(Vo,angle(Ad),'r');
plot(ae,(Ad),'r')
hold on
plot(ae,Ad1,'g');
hold on
plot(ae,Ad2,'b');
legend('H 0%', 'H 60%','H 100%');
xlabel(' Particle sand radius');
ylabel(' Amplitude of the Attenuation (db/km)');
grid

figure

plot(ae,(angle(Ad).*180./pi), 'r');
hold on
plot(ae,(angle(Ad1).*180./pi), 'g');
hold on
plot(ae,(angle(Ad2).*180./pi),'b');
hold off
legend('H 0%', 'H 60%','H 100%');
xlabel(' Particle sand radius');
ylabel(' phase of the Attenuation (degree)');
grid

